From a590931e85f2339d8ee9fdc6dda3b1b947e26395 Mon Sep 17 00:00:00 2001
From: basOS G <noxelia 4t gmail , com>
Date: Tue, 30 Dec 2008 19:47:29 +0200
Subject: [PATCH] Added a performance check to marquee filter

We preparse format string for the special case of user wanting to
print % , so passing %%, marking the string as unchanged to avoid
unneeded calls to time() and localtime()
---
 modules/video_filter/marq.c |   14 +++++++++++++-
 1 files changed, 13 insertions(+), 1 deletions(-)

diff --git a/modules/video_filter/marq.c b/modules/video_filter/marq.c
index 6fd8918..399496b 100644
--- a/modules/video_filter/marq.c
+++ b/modules/video_filter/marq.c
@@ -296,7 +296,19 @@ static subpicture_t *Filter( filter_t *p_filter, mtime_t date )
 
     p_sys->last_time = date;
 
-    if( !strchr( p_sys->psz_marquee, '%' )
+    /* in case we update marq often (some times per second) and we want to
+       print a % sign (feeding %%) treat the string as static*/
+    char* psz_pos = p_sys->psz_marquee ;
+    bool b_ftime = false ;
+    while ( !b_ftime && ( psz_pos = strchr( psz_pos, '%' ) ) != NULL )
+    {
+        if ( *++psz_pos != '%' )
+            b_ftime = true ;
+        else
+            ++psz_pos ;
+    }
+
+    if( !b_ftime
      && !strchr( p_sys->psz_marquee, '$' ) )
         p_sys->b_need_update = false;
 
-- 
1.5.4.3

